def daystr():
  from datetime import date
  dd=date.today()
  return "%d-%02d-%02d" % (dd.year, dd.month, dd.day)

def srtocn(sr):
  ls=[]
  for ch in sr:
    ls.append(ord(ch))
  return ls

def cntosr(ls):
  sr=''
  for ch in ls:
    sr=sr+chr(ch)
  return sr

def hftofl(sr):
  li=srtocn(sr)
  lo=[]
  for cd in li:
    if cd == 0x20:
      lo.append(0x3000)
    elif cd == 0x22:
      lo.append(0x201d)
    elif cd == 0x27:
      lo.append(0x2019)
    elif cd == 0x2d:
      lo.append(0x2500)
    elif cd == 0x7e:
      lo.append(0x301c)
    elif cd <= 0x7f and cd > 0x20:
      lo.append(cd+0xfee0)
    else:
      lo.append(cd)
  return cntosr(lo)

def ctype(ch):
  cd=ord(ch[0])
  if cd >= 0x0370 and cd <= 0x03ff:
    return 'gk'
  elif cd >= 0x3040 and cd <= 0x309f:
    return 'hk'
  elif cd >= 0x30a0 and cd <= 0x30ff:
    return 'kk'
  elif cd >= 0x4e00 and cd <= 0x9fbf:
    return 'kn'
  elif cd >= 0xff10 and cd <= 0xff19:
    return 'nm'
  elif cd >= 0x30 and cd <= 0x39:
    return 'nm'
  elif cd >= 0xFF21 and cd <= 0xFF3A:
    return 'al'
  elif cd >= 0xFF41 and cd <= 0xFF5A:
    return 'al'
  elif cd >= 65 and cd <= 90:
    return 'al'
  elif cd >= 97 and cd <= 122: 
    return 'al'
  else:
    return 'ot'

#decomposing string to text
def minep(sr, ss):
  sp=ss
  tp=sr.find('．', sp)
  while tp != -1:
    if tp == len(sr)-1 or ctype(sr[tp+1:tp+2]) != 'nm':
      return tp
    else:
      tp=sr.find('．', tp+1)

def dcsent(sr):
  ps=0
  pr=[]
  jp=sr.find('。')
  ep= minep(sr, 0)
  while jp > 0 or ep:
    if ep:
      if jp < 0 or jp > ep:
        pr.append(sr[ps:ep+1])
        ps=ep+1
      elif jp > 0:
        pr.append(sr[ps:jp+1])
        ps=jp+1
    else:
      pr.append(sr[ps:jp+1])
      ps=jp+1
    jp=sr.find('。', ps)
    ep= minep(sr, ps)
  if ps < len(sr) -1:
    pr.append(sr[ps:len(sr)])
  return pr

# document xml process
def getrec(fl):
  rv=''
  while True:
    ln=fl.readline()
    if not ln:
      return False
    ln=ln.rstrip()
    if ln[len(ln)-1]!='>':
      ln=ln+"\n"
    rv=rv+ln
    ps=ln.rfind('<')
    if ps>=0 and ln[ps:len(ln)]=='</REC>':
      return rv

def getpt(fg, rd, of):
  ss=of
  rs=[]
  while True:
    ps=rd.find('<'+fg, ss)
    pe=rd.find('</'+fg, ss)
    if ps<0 or pe<0:
      return rs
    cp=rd.find('>', ps)
    if cp<0:
      return rs
    rs.append(rd[cp+1:pe])
    ss=pe+1

def dcands(ls):
  rv=ls[0]
  for dt in ls[1:len(ls)]:
    rv=rv+"\t%s" % dt
  return rv

def dconld(ls):
  dn='(NULL'
  for el in ls:
    dn=dn+", '%s'" % el
  return dn+", 'batch', '%s')" % daystr()

def ddget(fl):
  rd=getrec(fl)
  if not rd:
    return False
  if 'ABST.P' in rd:
    ab=getpt('ABST.P', rd, 0)
  else:
    ab=getpt('ABST', rd, 0)
  if ab:
    ax=ab[0]
    if len(ab)>1:
      for tx in ab[1:len(ab)]:
        ax=ax+"\n"+tx
  else:
    ab=''
  tt=getpt('TITL', rd, 0)
  if tt:
    tt=tt[0]
  else:
    tt=''
  at=getpt('AUPK', rd, 0)
  if at:
    at=at[0]
  else:
    at=''
  ky=getpt('KYWD', rd, 0)
  if ky:
    ky=ky[0]
  else:
    ky=''
  pl=getpt('CONF', rd, 0)
  if pl:
    pl=pl[0]
  else:
    pl=''
  pd=getpt('CNFD', rd, 0)
  if pd:
    pd=pd[0].replace('. ', '-').split(' ')
    if pd:
      pd=pd[0]
    else:
      pd=''
  else:
    pd=''
  sc=getpt('SOCN', rd, 0)
  if sc:
    sc=sc[0]
  else:
    sc=''
  return [hftofl(tt), at, hftofl(ky), hftofl(ax), pl, pd, sc]

# database modify for candidates
def ckndrd(cd, cur):
  cur.execute("SELECT id, count FROM candidates WHERE name='%s'" % cd[0])
  dc=cur.fetchone()
  cur.execute("SELECT id FROM terms where name='%s'" % cd[0])
  dd=cur.fetchone()
  if not dc:
    vl="(NULL, '%s', '%s', '%s', '%s', 1" % (cd[0], cd[1], cd[2], cd[3])
    if dd:
      vl=vl+", 'y')"
    else:
      vl=vl+", 'u')"
    cur.execute("INSERT INTO candidates VALUES "+ vl)
  else:
    nc=int(dc[1])+1
    cur.execute("UPDATE candidates SET count=%d WHERE id=%s" % (nc, dc[0]))

# create rfdocs table
def rfdcr(dn, sn):
  import mysql.connector
  fl=open('/home/data/ntc1-u')
  con=mysql.connector.connect(host='localhost', db=dn, user='root', passwd='vijnapti')
  cur=con.cursor()
  rr=ddget(fl)
  while rr:
    if rr[6]==sn:
      cur.execute("INSERT INTO %s VALUES %s" % ('rfdocs', dconld(rr)))
    rr=ddget(fl)
  cur.close()
  con.close()

# count candidates
def cndcr(dn):
  import mysql.connector
  import chasen
  from morph import tmext, tmdata
  chasen.init("/home/data/%s/currc" % dn)
  con=mysql.connector.connect(host='localhost', db=dn, user='root', passwd='vijnapti')
  cur=con.cursor()
  cur.execute("SELECT id FROM rfdocs")
  dl=cur.fetchall()
  for ix in dl:
    cur.execute("SELECT title, abstract FROM rfdocs WHERE id=%d" % ix[0])
    td=cur.fetchone()
    tl=[]
    if td[0]!='':
      tl.append(td[0])
    if td[1]!='':
      for pt in td[1].split("\n"):
        tl=tl+dcsent(pt)
    wk=[]
    for tx in tl:
      cd=tmext(tx, chasen)
      for tm in cd:
        wk.append(tmdata(tm))
    for cd in wk:
      ckndrd(cd, cur)
  con.commit()
  cur.close()
  con.close()
